<template>
    <div class="mt-5">

        <b-row class="mb-4">
            <b-col sm="12" lg="6" class="mb-3"><h1>Productos</h1></b-col>
            <b-col md="6" class="d-none d-lg-block text-right">

                <content-loader v-if="categories.length == 0" :height="15" :speed="2" :animate="true" />

                <div v-else>
                    <!--<span class="mr-3">Filtrar</span>-->
                    <!--<b-form-group label="Mostrar">-->
                    <b-form-checkbox-group
                        id="categories-checkbox-group"
                        plain
                        v-model="selectedCategories"
                        :options="categories"
                        value-field="id"
                        text-field="name"
                        buttons
                        name="categories-checkbox-group"
                        button-variant="outline-secondary shadow-none" />
                </div>
            </b-col>
        </b-row>

        <b-row>
            <b-col xs="12" sm="6" md="4" lg="4" v-for="(product, i) in filteredProducts" :key="i">
                <div class="card mb-3" @mouseover="hoverProductIndex = i" @mouseout="hoverProductIndex = null">
                    <a :href="`/productos/${product.slug}`">
                        <b-img class="card-img-top"
                            :src="product.image_urls.full[0]"
                            :alt="product.name" />  
                    </a>                  
                    <div class="card-body">
                        <div class="text-center"><a class="product-title" :href="`/productos/${product.slug}`">{{ product.name }}</a></div>
                        <div class="text-center price"><strong>{{ product.formatted_price }}</strong></div>
                        <div class="text-center mt-2" :style="{visibility: hoverProductIndex == i && !isMobile ? 'visible' : 'hidden'}">
                            <buy-cta :product="product"></buy-cta>
                        </div>
                    </div>
                </div>
            </b-col>
        </b-row>
        <b-alert variant="warning" :show="products.length > 0 && filteredProducts.length == 0">
            No hay productos para mostrar.
        </b-alert>
    </div>
</template>

<style lang="scss">
    @import './node_modules/bootstrap/scss/functions';
    @import './node_modules/bootstrap/scss/variables';
    @import './node_modules/bootstrap/scss/mixins';

    #categories-checkbox-group {
        .btn {
            font-size: 0.8em;
            cursor: pointer;
            outline: none;
            &.btn-outline-secondary {
                &:hover {
                    background-color: white;
                    color: #6c757d;
                }
                &.active {
                    &:hover {
                        background-color: #6c757d;
                        color: white;
                    }
                }
            }
        }
    }

    .card {
        border: none;
        img.card-img-top {
            object-fit: cover;
            object-position: center;
            width: 100%;
            max-height: 200px;
            border-radius: 0;
        }
        background-color: transparent;
        .product-title {
            text-decoration: none;
            color: inherit;
            &:hover {
                color: inherit;
                text-decoration: underline;
            }
        }        
    }

    .price {
        font-size: 1.5em;
    }

    @include media-breakpoint-up(lg) {
        .hvrbox:hover .hvrbox-layer_top,
        .hvrbox.active .hvrbox-layer_top {
            opacity: 1;
        }
        .hvrbox.active .hvrbox-text_mobile {
            display: block;
        }
    }

    .btn-group {
        &:focus {
            outline: none;
        }
    }

</style>

<script>
    //import { BCard } from 'bootstrap-vue';
    import { filter } from 'lodash'
    import { BTooltip, BButtonGroup, BButton, BFormGroup, BFormCheckboxGroup, BAlert, BRow, BCol, BImg } from 'bootstrap-vue'
    import { isMobile } from 'mobile-device-detect';

    export default {
        components: {
            'b-tooltip': BTooltip,
            'b-button-group': BButtonGroup,
            'b-button': BButton,
            'b-form-group': BFormGroup,
            'b-form-checkbox-group': BFormCheckboxGroup,
            'b-alert': BAlert,
            'b-row': BRow,
            'b-col': BCol,
            'b-img': BImg
        },
        props: {
            products: {
                type: Array,
                required: true
            },
            categories: {
                type: Array,
                required: true
            }            
        },        
        data() {
            return {
                selectedCategories: [],
                hoverProductIndex: null,
                isMobile: isMobile
            };
        },
        computed: {
            filteredProducts: function () {
                if (this.selectedCategories.length > 0) {
                    return filter(this.products, product =>
                        this.selectedCategories.indexOf(product.category_id) != -1
                    );
                }
                return this.products;
            }
        }
    }
</script>
